<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: caesarVerfahren.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: caesarVerfahren.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>/**
* Verschluesselt den Klartext und ruft die Funktion fuer das Abspielen der Animation und die Ausgabe der Lösung auf.
* @global
* @function caesarVerschluesselung
* @param {event} evt Click-Event auf den Verschlüsseln-Button
*/

function caesarVerschluesselung(evt){
    var input = [];
    var index = 0;
    var result = [];
    var verschiebung = 0;
    var plainText = document.getElementById("inputField").value;
    
    clearTimeout(timer);
    verschiebung = caesarVerschiebung % 26;
    
    if(verschiebung === 0){
        alert("Drehe den inneren Ring der Caesar-Scheibe um die Verschiebung des Alphabets einzustellen.");
        document.getElementById("verschiebung").value = caesarVerschiebung;
        return false;
    } else {
        document.getElementById("verschiebung").value = caesarVerschiebung;
    }
    
    if(plainText == "" || plainText == " "){
        alert("Bitte Text eingeben.");
        return false;
    }
    
    var output = "";
    /** Hilfsvariablen */
    var res, resf;
   
/** Übersetzen in Großbuchstaben wegen Caesar-Scheibe */   
    plainText = plainText.toUpperCase();
    document.getElementById("inputField").value = plainText;
    for(var i = 0; i &lt; plainText.length; i++){
        input.push(plainText[i]);
        res = plainText.charCodeAt(i);
        if(checkChar(res) === false){
            alert("Bitte nur Buchstaben von A - Z eingeben!")
            return false;
        }
        if(64 &lt; res &amp;&amp; res &lt; 91){
            resf = res + verschiebung;
            if(resf > 90)
                resf = resf - 90 + 64;
               output = String.fromCharCode(resf);
               result.push(output);
            } else {
                output = plainText[i];
                result.push(output);
            }
        }
   
    crypAnimation(index, input, result);
}

/** 
* Spielt die Animation ab und gibt das Erbebnis der Verschlüsselung aus
* @global
* @function crypAnimation
* @param {number} index Aktueller Index im Array für die Eingabe und für das Ergebnis
* @param {string[]} input Enthält Buchstaben der Eingabe
* @param {string[]} result Enthält Buchstaben der Lösung
*/
function crypAnimation(index, input, result){ 
    
      animateCaesar = new CaesarShape();
    
      if(result.length > 1){
        weiterButton = new WeiterBtn();
        weiterButton.weiterContainer.x = (canvas.width/2 + crypBtnWidth/2 + offset) / scale;
        weiterButton.weiterContainer.y = (canvas.height/(1.1)) / scale;
        stage.addChild(weiterButton.weiterContainer);
    }
    
    document.getElementById("output").value = result[index];
    /** Animation für die Verschlüsselung */
        for(j = 0; j &lt; ringChars.length; j++){
            if(input[index] == ringChars[j]){
                
                var arcShape = new createjs.Shape();
                arcShape.graphics.beginStroke(black).beginFill(red).setStrokeStyle(2).arc(0, 0, arcRadius, 70 * (Math.PI/180), 110 * (Math.PI/180)).lineTo(0,0).closePath();
                arcShape.alpha = 0;
                arcShape.rotaion = labelRotation[j];
                arcShape.regY = Math.ceil(150 * scale);
                createjs.Tween.get(arcShape, {overwrite: true}).to({rotation: arcShape.rotaion, alpha:0}, 250, createjs.Ease.cubicOut).call(handleComplete);
                    function handleComplete(){
                        createjs.Tween.get(arcShape, {overwrite: true}).to({alpha:0.4}, 2500, createjs.Ease.cubicOut);
                     }
                animateCaesar.animationContainer.addChild(arcShape);
                stage.addChild(animateCaesar.animationContainer);
                stage.update();
                    if(result.length === 1){
                        removeShape(animateCaesar.animationContainer);
                    }
                
                break;
            }
        }
                  /** 
                  * Bei drücken des Weiter-Buttons wird nächste Animation abgespielt und nächster Buchstabe der Lösung ausgegeben.
                  * @param {event} evt Click-Event auf den Weiter-Button
                  */
                   weiterButton.weiterContainer.on("click", function(evt){
                       var wb = evt.currentTarget;
                      
                       clearTimeout(timer);
                       /** Container leeren */
                       animateCaesar.animationContainer.removeAllChildren();
                       ++index;
                       if(input[index] === " "){
                           document.getElementById("output").value += " ";
                       }
                       for(j = 0; j &lt; ringChars.length; j++){
                           if(input[index] == ringChars[j]){
                               var arcShape = new createjs.Shape();
                               arcShape.graphics.beginStroke(black).beginFill(red).setStrokeStyle(2).arc(0, 0, arcRadius, 70 * (Math.PI/180), 110 * (Math.PI/180)).lineTo(0,0).closePath();
                                arcShape.alpha = 0;
                                arcShape.rotaion = labelRotation[j];
                                arcShape.regY = Math.ceil(150 * scale);
                                createjs.Tween.get(arcShape, {overwrite: true}).to({rotation: arcShape.rotaion, alpha: 0}, 250, createjs.Ease.cubicOut).call(handleComplete);
                                    function handleComplete(){
                                        createjs.Tween.get(arcShape, {overwrite: true}).to({alpha:0.4}, 2500, createjs.Ease.cubicOut);
                                     }
        
                                animateCaesar.animationContainer.addChild(arcShape);
                                stage.addChild(animateCaesar.animationContainer);
                                stage.update();
                                
                                document.getElementById("output").value += result[index];
                               
                               if((index + 1) == result.length){
                                   removeBtn(wb);
                                   removeShape(animateCaesar.animationContainer, arcShape);
                               }
                               
                               break;
                           }
                       }
                   });   
   
}

/**
* Entschlüsselt den Geheimtext und ruft die Funktion für das Abspielen der Animation und die Ausgabe der Lösung auf.
* @global
* @function caesarEntschluesselung
* @param {event} evt Click-Event auf den Entschlüsseln-Button
*/
function caeasarEntschluesselung(evt){
    var input = [];
    var index = 0;
    var result = [];
    var verschiebung = 0;
    var cipherText = document.getElementById("inputField").value;
    document.getElementById("output").value = "";
    

    clearTimeout(timer);
   
    verschiebung = (caesarVerschiebung * (-1)) + 26;
    
    document.getElementById("verschiebung").value = caesarVerschiebung;
    
    var output = "";
    /** Hilfsvariablen */
    var res, resf;
   
/** Übersetzen in Großbuchstaben wegen Caesar-Scheibe */   
    cipherText = cipherText.toUpperCase();
    document.getElementById("inputField").value = cipherText;
    for(var i = 0; i &lt; cipherText.length; i++){
        input.push(cipherText[i]);
        res = cipherText.charCodeAt(i);
        if(checkChar(res) === false){
            alert("Bitte nur Buchstaben eingeben!")
            return false;
        }
        if(64 &lt; res &amp;&amp; res &lt; 91){
            resf = res + verschiebung;
            if(resf > 90)
                resf = resf - 90 + 64;
               output = String.fromCharCode(resf);
               result.push(output);
            } else {
                output = cipherText[i];
                result.push(output);
            }
        }
    
    encrypAnimation(index, input, result);
}

/** 
* Spielt die Animation ab und gibt das Erbebnis der Entschlüsselung aus
* @global
* @function encrypAnimation
* @param {number} index Aktueller Index im Array für die Eingabe und fuer das Ergebnis
* @param {string[]} input Enthält Buchstaben der Eingabe
* @param {string[]} result Enthält Buchstaben der Lösung
*/
function encrypAnimation(index, input, result){
    animateCaesar = new CaesarShape();
    
    if(result.length > 1){
        weiterButton = new WeiterBtn();
        weiterButton.weiterContainer.x = (canvas.width/2 + crypBtnWidth/2 + offset) / scale;
        weiterButton.weiterContainer.y = (canvas.height/(1.1)) / scale;
        stage.addChild(weiterButton.weiterContainer);
    }
    
     document.getElementById("output").value = result[index];
    
     /** Animation fuer die Entschlüsselung */
        for(j = 0; j &lt; ringChars.length; j++){
            if(input[index] == ringChars[j]){
                
                var arcShape = new createjs.Shape();
                arcShape.graphics.beginStroke(black).beginFill(blue).setStrokeStyle(2).arc(0, 0, arcRadius, 250 * (Math.PI/180), 290 * (Math.PI/180)).lineTo(0,0).closePath();
                //arcShape.graphics.lt(0,0);
                arcShape.alpha = 0;
                arcShape.rotaion = initialRotation[j];
                arcShape.regY = Math.ceil(90 * scale);
                createjs.Tween.get(arcShape, {overwrite: true}).to({rotation: arcShape.rotaion, alpha: 0}, 250, createjs.Ease.cubicOut).call(handleComplete);
                    function handleComplete(){
                         createjs.Tween.get(arcShape, {overwrite: true}).to({alpha:0.4}, 2500, createjs.Ease.cubicOut); 
                     }
        
                animateCaesar.animationContainer.addChild(arcShape);
                stage.addChild(animateCaesar.animationContainer);
                stage.update();
             
                     if(result.length === 1){
                        removeShape(animateCaesar.animationContainer);
                    }
                
                break;
            }
        }
                  /** 
                  * Bei drücken des Weiter-Buttons wird nächste Animation abgespielt und nächster Buchstabe der Lösung ausgegeben.
                  * @param {event} evt Click-Event auf den Weiter-Button
                  */
                   weiterButton.weiterContainer.on("click", function(evt){
                       var wb = evt.currentTarget;
                       
                       
                       clearTimeout(timer);
                       /** Container leeren */
                       animateCaesar.animationContainer.removeAllChildren();
                       ++index;
                       if(input[index] === " "){
                           document.getElementById("output").value += " ";
                       }
                       for(j = 0; j &lt; ringChars.length; j++){
                           if(input[index] == ringChars[j]){
                               var arcShape = new createjs.Shape();
                               arcShape.graphics.beginStroke(black).setStrokeStyle(2).beginFill(blue).arc(0, 0, arcRadius, 250 * (Math.PI/180), 290 * (Math.PI/180)).lineTo(0,0).closePath();
                                //arcShape.graphics.lt(0,0);
                                arcShape.alpha = 0;
                                arcShape.rotaion = initialRotation[j];
                                arcShape.regY = Math.ceil(90 * scale);
                                createjs.Tween.get(arcShape, {overwrite: true}).to({rotation: arcShape.rotaion, alpha: 0}, 250, createjs.Ease.cubicOut).call(handleComplete);
                                    function handleComplete(){
                                        createjs.Tween.get(arcShape, {overwrite: true}).to({alpha:0.4}, 2500, createjs.Ease.cubicOut); 
                                     }
        
                                animateCaesar.animationContainer.addChild(arcShape);
                                stage.addChild(animateCaesar.animationContainer);
                                stage.update();
                               
                                document.getElementById("output").value += result[index];
                               
                               if((index + 1) == result.length){
                                   removeBtn(wb);
                                   removeShape(animateCaesar.animationContainer, arcShape);
                               }
                               
                               break;
                           }
                       }
                   });   
   
}

/** Hilfsfunktionen */

/**
* Testet ob die Eingabe aus Buchstaben von A - z oder aus Leerzeichen besteht
* @global
* @function checkChar
* @param {number} text Char Code des aktuellen Buchstaben des Eingabetextes
* @returns {boolean} Gibt true zurück falls Char Code im Bereich von 65 - 90 oder 32, sonst false 
*/
function checkChar(text){
    return (text === 32) || (65 &lt;= text &amp;&amp; text &lt;= 90);
}

 /** 
 * Entfernt den Pfeil auf der Caesar-Scheibe nach 6 Sekunden
 * @global
 * @function removeShape
 * @param {Object} container Container-Object das zur Caesar-Scheibe hinzugefügt wurde
 * @param {Object} shape Shape-Object das für die Animation erzeugt wurde
 */
function removeShape(container, shape){
    timer = setTimeout(function(){
        createjs.Tween.removeAllTweens();                   
        stage.removeChild(container, shape);
    }, 6000);  
}

/** 
* Entfernt einen Button
* @global
* @function removeBtn
* @param {Object} btn Button-Object das übergeben wurde
*/
function removeBtn(btn){
        stage.removeChild(btn);
}
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Modules</h3><ul><li><a href="App.module_caesarModule.html">caesarModule</a></li></ul><h3>Classes</h3><ul><li><a href="App.module_caesarModule-CaesarShape.html">CaesarShape</a></li><li><a href="DecrypBtn.html">DecrypBtn</a></li><li><a href="EncrypBtn.html">EncrypBtn</a></li><li><a href="PruefButton.html">PruefButton</a></li><li><a href="SwitchButton.html">SwitchButton</a></li><li><a href="WeiterBtn.html">WeiterBtn</a></li><li><a href="ZurueckBtn.html">ZurueckBtn</a></li></ul><h3>Namespaces</h3><ul><li><a href="App.html">App</a></li></ul><h3>Global</h3><ul><li><a href="global.html#angle">angle</a></li><li><a href="global.html#animateCaesar">animateCaesar</a></li><li><a href="global.html#bg">bg</a></li><li><a href="global.html#caesarEntschluesselung">caesarEntschluesselung</a></li><li><a href="global.html#caesarVerschiebung">caesarVerschiebung</a></li><li><a href="global.html#caesarVerschluesselung">caesarVerschluesselung</a></li><li><a href="global.html#canvas">canvas</a></li><li><a href="global.html#checkChar">checkChar</a></li><li><a href="global.html#clickCounter">clickCounter</a></li><li><a href="global.html#crypAnimation">crypAnimation</a></li><li><a href="global.html#encrypAnimation">encrypAnimation</a></li><li><a href="global.html#initialRotation">initialRotation</a></li><li><a href="global.html#labelRotation">labelRotation</a></li><li><a href="global.html#onResize">onResize</a></li><li><a href="global.html#removeBtn">removeBtn</a></li><li><a href="global.html#removeShape">removeShape</a></li><li><a href="global.html#ringChars">ringChars</a></li><li><a href="global.html#rotationAngle">rotationAngle</a></li><li><a href="global.html#scale">scale</a></li><li><a href="global.html#setup">setup</a></li><li><a href="global.html#startApp">startApp</a></li><li><a href="global.html#tick">tick</a></li><li><a href="global.html#timer">timer</a></li><li><a href="global.html#weiterBtn">weiterBtn</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.5.5</a> on Sun Feb 25 2018 19:14:53 GMT+0100 (Mitteleuropäische Zeit)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
